package cn.jlsxwkj.moudles.userlist;

import cn.dev33.satoken.stp.StpUtil;
import io.swagger.v3.oas.annotations.Operation;
import jakarta.annotation.Resource;
import org.springframework.web.bind.annotation.*;

import javax.security.auth.login.LoginException;

/**
 * @author zh
 */
@RestController
@RequestMapping(("/user/"))
public class UserListController {

    @Resource
    private UserListService userListService;

    @Operation(summary = "登录")
    @PostMapping("/login")
    public UserVO login(@RequestParam String userName,
                          @RequestParam String userPassword) throws LoginException {
        return userListService.checkOrAddUser(userName, userPassword);
    }

    @Operation(summary = "登出")
    @GetMapping("/logout")
    public String logout() {
        StpUtil.logout();
        return "登出成功";
    }
}
