package cn.jlsxwkj.moudles.userlist;

import cn.dev33.satoken.secure.SaSecureUtil;
import cn.dev33.satoken.stp.StpUtil;
import cn.hutool.core.lang.Snowflake;
import jakarta.annotation.Resource;
import org.springframework.stereotype.Service;

import javax.security.auth.login.AccountException;
import javax.security.auth.login.FailedLoginException;
import javax.security.auth.login.LoginException;

/**
 * @author zh
 */
@Service
public class UserListService {

    @Resource
    private UserListMapper userListMapper;
    private final Snowflake snowflake = new Snowflake();

    public UserVO checkOrAddUser(String userName, String userPassword) throws LoginException {
        String sha512pwd = SaSecureUtil.sha512(userPassword);
        UserList userList = userListMapper.checkUser(userName);
        UserVO userVO = new UserVO();
        if (userList != null) {
            if (!userList.getUserPassword().contains(sha512pwd)) {
                throw new FailedLoginException("密码错误");
            }
            if (!StpUtil.isLogin()) {
                String userId = userList.getUserId();
                StpUtil.login(userId, false);
                userVO.setUserId(userId);
                userVO.setUserName(userList.getUserName());
                userVO.setMessage("登录成功");
                return userVO;
            }
            throw new LoginException("请勿重复登录");
        }
        userList = new UserList();
        userList.setUserId(snowflake.nextIdStr());
        userList.setUserName(userName);
        userList.setUserPassword(sha512pwd);
        Integer rows = userListMapper.authUser(userList);
        if (rows > 0) {
            String userId = userList.getUserId();
            StpUtil.login(userId, false);
            userVO.setUserId(userId);
            userVO.setUserName(userList.getUserName());
            userVO.setMessage("注册成功");
            return userVO;

        }
        throw new AccountException("注册失败");
    }
}
